package com.seostella.catchcrashreport;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;

import android.app.Activity;
import android.os.Bundle;

public class CatchCrashReportActivity extends Activity {
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
		defaultExceptionHandler = Thread.getDefaultUncaughtExceptionHandler();
        Thread.setDefaultUncaughtExceptionHandler(uncaughtExceptionHandler);
        
        int a = 1;
        a--;
        int b = 10 / a;
    }
    
	public void startExitChecker(){
        new Thread(){
        	private static final long WAIT_TIME = 10000;
        	private static final long SMALL_WAIT_TIME = 1000;
        	
        	public void run(){
        		try{
            		long startTime = System.currentTimeMillis();
            		boolean forceClose = true;
            		while( System.currentTimeMillis() - startTime < WAIT_TIME ){
            			try {
							Thread.sleep( SMALL_WAIT_TIME );
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
            			if( CatchCrashReportActivity.this == null ){
            				forceClose = false;
            				break;
            			}
            		}
            		if( forceClose ){
            			CatchCrashReportActivity.this.finish();
            		}
        		} catch( Exception e ){
        		}
        	}
        }.start();
	}    
    
    Thread.UncaughtExceptionHandler defaultExceptionHandler;
    Thread.UncaughtExceptionHandler uncaughtExceptionHandler = new Thread.UncaughtExceptionHandler() {

        @Override
        public void uncaughtException(Thread t, Throwable e) {
        	e.printStackTrace();
        	// do something
        	
        	final Writer result = new StringWriter();
            final PrintWriter printWriter = new PrintWriter(result);
            e.printStackTrace(printWriter);
            String stacktrace = result.toString();
            printWriter.close();
            
            // send stacktrace data 
        	startExitChecker();
        	defaultExceptionHandler.uncaughtException(t, e);
        }
    };
    
}